const body = document.createElement('body')
const root = document.createElement('div')
document.title = "Strapp.io Client"
body.appendChild(root)
document.body = body

/* Poll the server. Send get request, wait for timeout, send another request.
   Do this until...? */
function pollServerTimeout(url, data, resolve, reject) {
  console.log('Polling server with offer ' + data)
  const request = XMLHttpRequest()
  request.open('GET', url)
  request.setRequestHeader('Content-Type', 'application/json' )
  request.onreadystatechange = () => {
    if (request.status === 200) {
      console.log('recieved answer from host ' + request.response)
      resolve(request.response)
    }
    else if (request.status === 504) {
      pollServerTimeout(url, resolve, reject)
    }
    else {
      reject('server errored out with ' + request.status)
    }
  }
  request.send(data)
}

/* TODO: Possible to pass resolve/reject to functions? */
function pollServer(url, clientPubKey, func) {
  return new Promise((resolve, reject) => {
    func(url, clientPubKey, resolve, reject )
  })
}
/* If https connection, should be already defined. If not https,*/
function getPublicKey() {
  /* Check local storage for public key */
  if (window.localStorage.getItem('public-key') === undefined) {
    /* If doesn't exist, generate public and private key pair, store in
    local storage */
    crypto.subtle.generateKey({name:'RSA-OAEP', length: 192}, true, ['encrypt', 'decrypt'])
      .then((keyPair) => {
        /* TODO: Do we need to store the private key as well? */
        window.localStorage.setItem('public-key', keyPair.type.public.toString())
      })
  }
    console.log(window.localStorage.getItem('public-key'))
    return window.localStorage.getItem('public-key')
}

/* Create, set, and get client Offer. Poll server for host answer.
   Set host answer as client remoteDescription */
const cpc = new RTCPeerConnection()
cpc.createOffer().then((offer) => {
  console.log('creating offer which is ' + offer)
  return cpc.setLocalDescription(offer)
}).then(() => {
  console.log('sessionDescriptionInit = ' + cpc.localDescription)
  const cpk = getPublicKey()
  let offer = {
    cmd: '> sdp pubKey'
    sdp: cpc.localDescription,
    pubKey: cpk
  }
  /* Poll for answer */
  return pollServer(window.location, offer, pollServerTimeout)
}).then((answer) => {
  /* TODO: Extract sdp from answer ?*/
  console.log(answer)
  /* State machine to parse answer */
  cpc.setRemoteDescription(answer.sdp)
})
